Index: trunk/SophyaProg/PMixer/Makefile
===================================================================
--- trunk/SophyaProg/PMixer/Makefile	(revision 2836)
+++ trunk/SophyaProg/PMixer/Makefile	(revision 3007)
@@ -39,24 +39,64 @@
 	$(CXXLINK) $(CXXTEMPFLG) -o $@ $(SOPHYAOBJP)Sph2Sph.o $(SOPHYAEXTSLBLIST)
  
-$(SOPHYAOBJP)Sph2Sph.o: Sph2Sph.cc $(SOPHYAINCP)sopnamsp.h \
-  pmixer.h $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+$(SOPHYAOBJP)easyTest.o: easyTest.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)blackbody.h \
+  $(SOPHYAINCP)radspec.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)specresp.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)convtools.h \
+  $(SOPHYAINCP)radspecvector.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)specrespvector.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)squarefilt.h \
+  $(SOPHYAINCP)gaussfilt.h \
+  $(SOPHYAINCP)trianglefilt.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  easyTest.cc
+ 
+$(SOPHYAOBJP)extractRS.o: extractRS.cc \
+  $(SOPHYAINCP)sopnamsp.h pmixer.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -69,4 +109,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -78,12 +119,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -99,58 +145,32 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  Sph2Sph.cc
- 
-$(SOPHYAOBJP)easyTest.o: easyTest.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)blackbody.h \
-  $(SOPHYAINCP)radspec.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)specresp.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)convtools.h \
-  $(SOPHYAINCP)radspecvector.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)specrespvector.h \
-  $(SOPHYAINCP)squarefilt.h \
-  $(SOPHYAINCP)gaussfilt.h \
-  $(SOPHYAINCP)trianglefilt.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  easyTest.cc
- 
-$(SOPHYAOBJP)extractRS.o: extractRS.cc \
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  extractRS.cc
+ 
+$(SOPHYAOBJP)skymixer.o: skymixer.cc \
   $(SOPHYAINCP)sopnamsp.h pmixer.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -163,4 +183,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -172,12 +193,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -193,27 +219,32 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  extractRS.cc
- 
-$(SOPHYAOBJP)skymixer.o: skymixer.cc \
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  skymixer.cc
+ 
+$(SOPHYAOBJP)Sph2Sph.o: Sph2Sph.cc \
   $(SOPHYAINCP)sopnamsp.h pmixer.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -226,4 +257,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -235,12 +267,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -256,26 +293,31 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  skymixer.cc
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  Sph2Sph.cc
  
 $(SOPHYAOBJP)tgrsr.o: tgrsr.cc $(SOPHYAINCP)sopnamsp.h \
   pmixer.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -288,4 +330,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -297,12 +340,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -323,21 +371,26 @@
   pmixer.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -350,4 +403,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -359,12 +413,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
Index: trunk/SophyaProg/PMixer/smakefile
===================================================================
--- trunk/SophyaProg/PMixer/smakefile	(revision 2836)
+++ trunk/SophyaProg/PMixer/smakefile	(revision 3007)
@@ -39,23 +39,64 @@
 	$(CXXLINK) $(CXXTEMPFLG) -o $@ $(SOPHYAOBJP)Sph2Sph.o $(SOPHYAEXTSLBLIST)
  
-$(SOPHYAOBJP)Sph2Sph.o: Sph2Sph.cc $(SOPHYAINCP)sopnamsp.h \
-  pmixer.h $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+$(SOPHYAOBJP)easyTest.o: easyTest.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)blackbody.h \
+  $(SOPHYAINCP)radspec.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)specresp.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)convtools.h \
+  $(SOPHYAINCP)radspecvector.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)specrespvector.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)squarefilt.h \
+  $(SOPHYAINCP)gaussfilt.h \
+  $(SOPHYAINCP)trianglefilt.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  easyTest.cc
+ 
+$(SOPHYAOBJP)extractRS.o: extractRS.cc \
+  $(SOPHYAINCP)sopnamsp.h pmixer.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -68,4 +109,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -77,12 +119,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -98,56 +145,32 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  Sph2Sph.cc
- 
-$(SOPHYAOBJP)easyTest.o: easyTest.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)blackbody.h \
-  $(SOPHYAINCP)radspec.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)specresp.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)convtools.h \
-  $(SOPHYAINCP)radspecvector.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)specrespvector.h \
-  $(SOPHYAINCP)squarefilt.h \
-  $(SOPHYAINCP)gaussfilt.h \
-  $(SOPHYAINCP)trianglefilt.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  easyTest.cc
- 
-$(SOPHYAOBJP)extractRS.o: extractRS.cc \
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  extractRS.cc
+ 
+$(SOPHYAOBJP)skymixer.o: skymixer.cc \
   $(SOPHYAINCP)sopnamsp.h pmixer.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -160,4 +183,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -169,12 +193,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -190,26 +219,32 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  extractRS.cc
- 
-$(SOPHYAOBJP)skymixer.o: skymixer.cc \
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  skymixer.cc
+ 
+$(SOPHYAOBJP)Sph2Sph.o: Sph2Sph.cc \
   $(SOPHYAINCP)sopnamsp.h pmixer.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -222,4 +257,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -231,12 +267,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -252,25 +293,31 @@
   $(SOPHYAINCP)bruit.h \
   $(SOPHYAINCP)mapoperation.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  skymixer.cc
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  Sph2Sph.cc
  
 $(SOPHYAOBJP)tgrsr.o: tgrsr.cc $(SOPHYAINCP)sopnamsp.h \
   pmixer.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -283,4 +330,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -292,12 +340,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -318,20 +371,26 @@
   pmixer.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -344,4 +403,5 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -353,12 +413,17 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
   $(SOPHYAINCP)HEALPixUtils.h \
   $(SOPHYAINCP)fitsspherehealpix.h \
   $(SOPHYAINCP)fitsfile.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
+  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
